Index: TWiki/UI/Manage.pm
===================================================================
--- TWiki/UI/Manage.pm	(revision 13172)
+++ TWiki/UI/Manage.pm	(working copy)
@@ -39,7 +39,7 @@
 
 =pod
 
----++ StaticMethod manage( $session )
+---++ StaticMethod manage()
 
 =manage= command handler.
 This method is designed to be
@@ -48,22 +48,20 @@
 =cut
 
 sub manage {
-    my $session = shift;
+    my $action = $TWiki::SESSION->{cgiQuery}->param( 'action' );
 
-    my $action = $session->{cgiQuery}->param( 'action' );
-
     if( $action eq 'createweb' ) {
-        _createWeb( $session );
+        _createWeb( );
     } elsif( $action eq 'changePassword' ) {
-        TWiki::UI::Register::changePassword( $session );
+        TWiki::UI::Register::changePassword( );
     } elsif ($action eq 'bulkRegister') {
-        TWiki::UI::Register::bulkRegister( $session );
+        TWiki::UI::Register::bulkRegister( );
     } elsif( $action eq 'deleteUserAccount' ) {
-        _removeUser( $session );
+        _removeUser( );
     } elsif( $action eq 'editSettings' ) {
-        _editSettings( $session );
+        _editSettings( );
     } elsif( $action eq 'saveSettings' ) {
-        _saveSettings( $session );
+        _saveSettings( );
     } elsif( $action ) {
         throw TWiki::OopsException( 'attention',
                                     def => 'unrecognized_action',
@@ -76,13 +74,11 @@
 # Renames the user's topic (with renaming all links) and
 # removes user entry from passwords. CGI parameters:
 sub _removeUser {
-    my $session = shift;
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $user = $TWiki::SESSION->{user};
 
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
-    my $query = $session->{cgiQuery};
-    my $user = $session->{user};
-
     my $password = $query->param( 'password' );
 
     # check if user entry exists
@@ -134,13 +130,11 @@
 }
 
 sub _createWeb {
-    my $session = shift;
+    my $topicName = $TWiki::SESSION->{topicName};
+    my $webName = $TWiki::SESSION->{webName};
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $user = $TWiki::SESSION->{user};
 
-    my $topicName = $session->{topicName};
-    my $webName = $session->{webName};
-    my $query = $session->{cgiQuery};
-    my $user = $session->{user};
-
     my $webBGColor = $query->param( 'webbgcolor' ) || '';
     my $siteMapWhat = $query->param( 'sitemapwhat' ) || '';
     my $siteMapUseTo = $query->param( 'sitemapuseto' ) || '';
@@ -151,8 +145,8 @@
     if( $webName =~ m|^(.*)[./](.*?)$| ) {
         $parent = $1;
     }
-    TWiki::UI::checkAccess( $session, $parent, undef,
-                            'CHANGE', $session->{user} );
+    TWiki::UI::checkAccess( $parent, undef,
+                            'CHANGE', $TWiki::SESSION->{user} );
 
     my $newWeb = $query->param( 'newweb' ) || '';
     unless( $newWeb ) {
@@ -165,7 +159,7 @@
     $newWeb = TWiki::Sandbox::untaintUnchecked( $newWeb );
 
     my $baseWeb = $query->param( 'baseweb' ) || '';
-    unless( $session->{store}->webExists( $baseWeb )) {
+    unless( $TWiki::STORE->webExists( $baseWeb )) {
         throw TWiki::OopsException
           ( 'attention', def => 'base_web_missing', params => $baseWeb );
     }
@@ -175,7 +169,7 @@
     # SMELL: check that it is a valid topic name?
     $newTopic = TWiki::Sandbox::untaintUnchecked( $newTopic );
 
-    if( $session->{store}->webExists( $newWeb )) {
+    if( $TWiki::STORE->webExists( $newWeb )) {
         throw TWiki::OopsException
           ( 'attention', def => 'web_exists', params => $newWeb );
     }
@@ -196,7 +190,7 @@
       };
     $opts->{SITEMAPLIST} = 'on' if( $siteMapWhat );
 
-    my $err = $session->{store}->createWeb( $user, $newWeb, $baseWeb, $opts );
+    my $err = $TWiki::STORE->createWeb( $user, $newWeb, $baseWeb, $opts );
     if( $err ) {
         throw TWiki::OopsException
           ( 'attention', def => 'web_creation_error',
@@ -213,7 +207,7 @@
 
 =pod
 
----++ StaticMethod rename( $session )
+---++ StaticMethod rename( )
 
 =rename= command handler.
 This method is designed to be
@@ -233,15 +227,13 @@
 =cut
 
 sub rename {
-    my $session = shift;
-
-    my $oldTopic = $session->{topicName};
-    my $oldWeb = $session->{webName};
-    my $query = $session->{cgiQuery};
+    my $oldTopic = $TWiki::SESSION->{topicName};
+    my $oldWeb = $TWiki::SESSION->{webName};
+    my $query = $TWiki::SESSION->{cgiQuery};
     my $action = $query->param( 'action' ) || '';
 
     if( $action eq 'renameweb' ) {
-        _renameweb( $session );
+        _renameweb( $TWiki::SESSION );
         return;
     }
 
@@ -264,7 +256,6 @@
 
     my $confirm = $query->param( 'confirm' );
     my $doAllowNonWikiWord = $query->param( 'nonwikiword' ) || '';
-    my $store = $session->{store};
 
     $newTopic =~ s/\s//go;
     $newTopic =~ s/$TWiki::cfg{NameFilter}//go;
@@ -272,14 +263,14 @@
 
     $attachment ||= '';
 
-    TWiki::UI::checkWebExists( $session, $oldWeb, $oldTopic, 'rename' );
+    TWiki::UI::checkWebExists( $oldWeb, $oldTopic, 'rename' );
     # Item3270: Wrap topic existence into extra try/catch block to
     #           check for the same name starting with a lower case letter.
     try {
-        TWiki::UI::checkTopicExists( $session, $oldWeb, $oldTopic, 'rename');
+        TWiki::UI::checkTopicExists( $oldWeb, $oldTopic, 'rename');
     } catch TWiki::OopsException with {
         $oldTopic = lcfirst $oldTopic;
-        TWiki::UI::checkTopicExists( $session, $oldWeb, $oldTopic, 'rename');
+        TWiki::UI::checkTopicExists( $oldWeb, $oldTopic, 'rename');
     };
 
     if( $newTopic && !TWiki::isValidWikiWord( $newTopic ) ) {
@@ -298,7 +289,7 @@
 
     if ( $attachment) {
         # Does old attachment exist?
-        unless( $store->attachmentExists( $oldWeb, $oldTopic,
+        unless( $TWiki::STORE->attachmentExists( $oldWeb, $oldTopic,
                                           $attachment )) {
 			my $tmplname = $query->param( 'template' ) || '';
             throw TWiki::OopsException(
@@ -309,16 +300,15 @@
                 params => [
                     $newWeb, $newTopic,
                     $attachment,
-                    $session->{i18n}->maketext('Attachment does not exist')
+                    $TWiki::I18N->maketext('Attachment does not exist')
                    ] );
         }
 
         if( $newWeb && $newTopic ) {
-            TWiki::UI::checkTopicExists( $session, $newWeb,
-                                         $newTopic, 'rename');
+            TWiki::UI::checkTopicExists( $newWeb, $newTopic, 'rename');
 
             # does new attachment already exist?
-            if( $store->attachmentExists( $newWeb, $newTopic,
+            if( $TWiki::STORE->attachmentExists( $newWeb, $newTopic,
                                           $attachment )) {
                 throw TWiki::OopsException(
                     'attention',
@@ -328,17 +318,17 @@
                     params => [
                         $newWeb, $newTopic,
                         $attachment,
-                        $session->{i18n}->maketext(
+                        $TWiki::I18N->maketext(
                             'Attachment already exists in new topic')
                        ] );
             }
         } # else fall through to new topic screen
     } elsif( $newTopic ) {
         ( $newWeb, $newTopic ) =
-          $session->normalizeWebTopicName( $newWeb, $newTopic );
+          $TWiki::SESSION->normalizeWebTopicName( $newWeb, $newTopic );
 
-        TWiki::UI::checkWebExists( $session, $newWeb, $newTopic, 'rename' );
-        if( $store->topicExists( $newWeb, $newTopic)) {
+        TWiki::UI::checkWebExists( $newWeb, $newTopic, 'rename' );
+        if( $TWiki::STORE->topicExists( $newWeb, $newTopic)) {
             throw TWiki::OopsException( 'attention',
                                         def => 'rename_topic_exists',
                                         web => $oldWeb,
@@ -347,15 +337,15 @@
         }
     }
 
-    TWiki::UI::checkAccess( $session, $oldWeb, $oldTopic,
-                            'RENAME', $session->{user} );
+    TWiki::UI::checkAccess( $oldWeb, $oldTopic,
+                            'RENAME', $TWiki::SESSION->{user} );
 
     # Has user selected new name yet?
     if( ! $newTopic || $confirm ) {
         # Must be able to view the source to rename it
-        TWiki::UI::checkAccess( $session, $oldWeb, $oldTopic,
-                                'VIEW', $session->{user} );
-        _newTopicScreen( $session,
+        TWiki::UI::checkAccess( $oldWeb, $oldTopic,
+                                'VIEW', $TWiki::SESSION->{user} );
+        _newTopicScreen( $TWiki::SESSION,
                          $oldWeb, $oldTopic,
                          $newWeb, $newTopic,
                          $attachment,
@@ -367,9 +357,9 @@
     my $refs;
     unless( $attachment ) {
         $refs = _getReferringTopicsListFromURL
-          ( $session, $oldWeb, $oldTopic, $newWeb, $newTopic );
+          ( $TWiki::SESSION, $oldWeb, $oldTopic, $newWeb, $newTopic );
     }
-    move( $session, $oldWeb, $oldTopic, $newWeb, $newTopic,
+    move( $oldWeb, $oldTopic, $newWeb, $newTopic,
           $attachment, $refs );
 
     my $new_url;
@@ -380,34 +370,34 @@
 
         if( $attachment ) {
             # go back to old topic after deleting an attachment
-            $new_url = $session->getScriptUrl( 0, 'view', $oldWeb, $oldTopic );
+            $new_url = $TWiki::SESSION->getScriptUrl( 0, 'view', $oldWeb, $oldTopic );
 
         } else {
             # redirect to parent topic, if set
             my ( $meta, $text ) =
-              $store->readTopic( undef, $newWeb, $newTopic, undef );
+              $TWiki::STORE->readTopic( undef, $newWeb, $newTopic, undef );
             my $parent = $meta->get( 'TOPICPARENT' );
             my( $parentWeb, $parentTopic );
             if( $parent && defined $parent->{name} ) {
                 ( $parentWeb, $parentTopic ) =
-                  $session->normalizeWebTopicName( '', $parent->{name} );
+                  $TWiki::SESSION->normalizeWebTopicName( '', $parent->{name} );
             }
             if( $parentTopic &&
                 !( $parentWeb eq $oldTopic && $parentTopic eq $oldTopic ) &&
-                  $store->topicExists( $parentWeb, $parentTopic ) ) {
-                $new_url = $session->getScriptUrl(
+                  $TWiki::STORE->topicExists( $parentWeb, $parentTopic ) ) {
+                $new_url = $TWiki::SESSION->getScriptUrl(
                     0, 'view', $parentWeb, $parentTopic );
             } else {
-                $new_url = $session->getScriptUrl( 0, 'view', $oldWeb,
+                $new_url = $TWiki::SESSION->getScriptUrl( 0, 'view', $oldWeb,
                                                    $TWiki::cfg{HomeTopicName});
             }
         }
     } else {
         #redirect to new topic
-        $new_url = $session->getScriptUrl( 0, 'view', $newWeb, $newTopic );
+        $new_url = $TWiki::SESSION->getScriptUrl( 0, 'view', $newWeb, $newTopic );
     }
 
-    $session->redirect( $new_url );
+    $TWiki::SESSION->redirect( $new_url );
 }
 
 #| =skin= | skin(s) to use |
@@ -415,12 +405,10 @@
 #| =newparentweb= | new parent web name |
 #| =confirm= | if defined, requires a second level of confirmation.  Currently accepted values are "getlock", "continue", and "cancel" |
 sub _renameweb {
-    my $session = shift;
+    my $oldWeb = $TWiki::SESSION->{webName};
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $user = $TWiki::SESSION->{user};
 
-    my $oldWeb = $session->{webName};
-    my $query = $session->{cgiQuery};
-    my $user = $session->{user};
-
     my $newParentWeb = $query->param( 'newparentweb' ) || '';
     unless ( !$newParentWeb || TWiki::isValidWebName( $newParentWeb, 1 )) {
         throw TWiki::OopsException
@@ -451,21 +439,19 @@
     my $breakLock = $query->param( 'breaklock' );
     my $confirm = $query->param( 'confirm' ) || '';
     my $doAllowNonWikiWord = $query->param( 'nonwikiword' ) || '';
-    my $store = $session->{store};
-    my $security = $session->{security};
+    my $security = $TWiki::ACCESS;
 
     TWiki::UI::checkWebExists(
-        $session, $oldWeb, $TWiki::cfg{WebPrefsTopicName}, 'rename' );
+        $oldWeb, $TWiki::cfg{WebPrefsTopicName}, 'rename' );
 
     if( $newWeb ) {
         if( $newParentWeb ) {
             # SMELL: need to check change permissions of new parent web
             TWiki::UI::checkWebExists(
-                $session, $newParentWeb,
-                $TWiki::cfg{WebPrefsTopicName}, 'rename' );
+                $newParentWeb, $TWiki::cfg{WebPrefsTopicName}, 'rename' );
         }
 
-        if( $store->webExists( $newWeb )) {
+        if( $TWiki::STORE->webExists( $newWeb )) {
             throw TWiki::OopsException(
                 'attention',
                 def => 'rename_web_exists',
@@ -489,8 +475,8 @@
 
         # get a topic list for all the topics referring to this web,
         # and build up a hash containing permissions and lock info.
-        $refs0 = getReferringTopics( $session, $oldWeb, undef, 0 );
-        $refs1 = getReferringTopics( $session, $oldWeb, undef, 1 );
+        $refs0 = getReferringTopics( $TWiki::SESSION, $oldWeb, undef, 0 );
+        $refs1 = getReferringTopics( $TWiki::SESSION, $oldWeb, undef, 1 );
         foreach my $ref (sort keys %$refs0) {
             $refs{$ref} = $refs0->{$ref};
         }
@@ -511,13 +497,13 @@
                 $webIter = TWiki::Sandbox::untaintUnchecked( $webIter );
                 $webTopic = TWiki::Sandbox::untaintUnchecked( $webTopic );
                 if($confirm eq 'getlock') {
-                    $store->setLease( $webIter, $webTopic, $user,
+                    $TWiki::STORE->setLease( $webIter, $webTopic, $user,
                                       $TWiki::cfg{LeaseLength});
-                    $lease_ref=$store->getLease($webIter,$webTopic);
+                    $lease_ref=$TWiki::STORE->getLease($webIter,$webTopic);
                 } elsif ($confirm eq 'cancel') {
-                    $lease_ref=$store->getLease($webIter,$webTopic);
+                    $lease_ref=$TWiki::STORE->getLease($webIter,$webTopic);
                     if($lease_ref->{user} eq $user) {
-                        $store->clearLease( $webIter, $webTopic );
+                        $TWiki::STORE->clearLease( $webIter, $webTopic );
                     }
                 }
                 my $wit = $webIter.'/'.$webTopic;
@@ -543,21 +529,21 @@
 
         # get a topic list for this web and all its subwebs, and build
         # up a hash containing permissions and lock info.
-        (@webList) = $store->getListOfWebs('public',$oldWeb);
+        (@webList) = $TWiki::STORE->getListOfWebs('public',$oldWeb);
         unshift(@webList,$oldWeb);
         foreach my $webIter (@webList) {
             $webIter = TWiki::Sandbox::untaintUnchecked( $webIter );
-            my @webTopicList=$store->getTopicNames($webIter);
+            my @webTopicList=$TWiki::STORE->getTopicNames($webIter);
             foreach my $webTopic (@webTopicList) {
                 $webTopic = TWiki::Sandbox::untaintUnchecked( $webTopic );
                 if( $confirm eq 'getlock' ) {
-                    $store->setLease( $webIter, $webTopic, $user,
+                    $TWiki::STORE->setLease( $webIter, $webTopic, $user,
                                       $TWiki::cfg{LeaseLength});
-                    $lease_ref = $store->getLease($webIter,$webTopic);
+                    $lease_ref = $TWiki::STORE->getLease($webIter,$webTopic);
                 } elsif ($confirm eq 'cancel') {
-                    $lease_ref = $store->getLease($webIter,$webTopic);
+                    $lease_ref = $TWiki::STORE->getLease($webIter,$webTopic);
                     if( $lease_ref->{user} eq $user ) {
-                        $store->clearLease( $webIter, $webTopic );
+                        $TWiki::STORE->clearLease( $webIter, $webTopic );
                     }
                 }
                 my $wit = $webIter.'/'.$webTopic;
@@ -612,16 +598,16 @@
                       @{$webTopicInfo{movelocked}} ) {
                     $nocontinue = 'style="display:none;"';
                 }
-                my $mvd = join(' ', @{$webTopicInfo{movedenied}} ) || ($session->{i18n}->maketext('(none)'));
+                my $mvd = join(' ', @{$webTopicInfo{movedenied}} ) || ($TWiki::I18N->maketext('(none)'));
                 $mvd = substr($mvd, 0, 300).'... (more)'
                   if( length($mvd) > 300);
-                my $mvl = join(' ', @{$webTopicInfo{movelocked}} ) || ($session->{i18n}->maketext('(none)'));
+                my $mvl = join(' ', @{$webTopicInfo{movelocked}} ) || ($TWiki::I18N->maketext('(none)'));
                 $mvl = substr($mvl, 0, 300).'... (more)'
                   if( length($mvl) > 300);
-                my $mdd = join(' ', @{$webTopicInfo{modifydenied}} ) || ($session->{i18n}->maketext('(none)'));
+                my $mdd = join(' ', @{$webTopicInfo{modifydenied}} ) || ($TWiki::I18N->maketext('(none)'));
                 $mdd = substr($mdd, 0, 300).'... (more)'
                   if( length($mdd) > 300);
-                my $mdl = join(' ', @{$webTopicInfo{modifylocked}} ) || ($session->{i18n}->maketext('(none)'));
+                my $mdl = join(' ', @{$webTopicInfo{modifylocked}} ) || ($TWiki::I18N->maketext('(none)'));
                 $mdl = substr($mdl, 0, 300).'... (more)'
                   if( length($mdl) > 300);
                 throw TWiki::OopsException(
@@ -638,14 +624,14 @@
 
         if ($confirm eq 'cancel') {
             # redirect to original web
-            my $viewURL = $session->getScriptUrl( 0, 'view',
+            my $viewURL = $TWiki::SESSION->getScriptUrl( 0, 'view',
                 $oldWeb, $TWiki::cfg{HomeTopicName});
-            $session->redirect( $viewURL );
+            $TWiki::SESSION->redirect( $viewURL );
         } elsif( $confirm ne 'getlock' ||
                    ($confirm eq 'getlock' &&
                       $modifyingLockedTopics && $movingLockedTopics )) {
             # Has user selected new name yet?
-            _newWebScreen( $session, $oldWeb, $newWeb,
+            _newWebScreen( $TWiki::SESSION, $oldWeb, $newWeb,
                            $confirm, \%webTopicInfo);
             return;
         }
@@ -653,21 +639,21 @@
 
     # Update references in referring pages 
     my $refs = _getReferringTopicsListFromURL(
-        $session, $oldWeb, $TWiki::cfg{HomeTopicName},
+        $TWiki::SESSION, $oldWeb, $TWiki::cfg{HomeTopicName},
         $newWeb, $TWiki::cfg{HomeTopicName} );
 
     # Now, we can move the web.
-    _moveWeb( $session, $oldWeb, $newWeb, $refs );
+    _moveWeb( $TWiki::SESSION, $oldWeb, $newWeb, $refs );
 
     # now remove lease on all topics inside $newWeb.
-    my (@webList) = $store->getListOfWebs('public',$newWeb);
+    my (@webList) = $TWiki::STORE->getListOfWebs('public',$newWeb);
     unshift(@webList,$newWeb);
     foreach my $webIter (@webList) {
         $webIter = TWiki::Sandbox::untaintUnchecked( $webIter );
-        my @webTopicList=$store->getTopicNames($webIter);
+        my @webTopicList=$TWiki::STORE->getTopicNames($webIter);
         foreach my $webTopic (@webTopicList) {
             $webTopic = TWiki::Sandbox::untaintUnchecked( $webTopic );
-            $store->clearLease( $webIter, $webTopic );
+            $TWiki::STORE->clearLease( $webIter, $webTopic );
         }
     }
 
@@ -679,7 +665,7 @@
         $webTopic = TWiki::Sandbox::untaintUnchecked( $webTopic );
         my $webIter=join("/",@path);
         $webIter = TWiki::Sandbox::untaintUnchecked( $webIter );
-        $store->clearLease( $webIter, $webTopic );
+        $TWiki::STORE->clearLease( $webIter, $webTopic );
     }
 
     my $new_url = '';
@@ -688,29 +674,28 @@
 
         # redirect to parent
         if( $oldParentWeb ) {
-            $new_url = $session->getScriptUrl( 0, 'view',
+            $new_url = $TWiki::SESSION->getScriptUrl( 0, 'view',
                 $oldParentWeb, $TWiki::cfg{HomeTopicName} );
         } else {
-            $new_url = $session->getScriptUrl( 0, 'view',
+            $new_url = $TWiki::SESSION->getScriptUrl( 0, 'view',
                 $TWiki::cfg{UsersWebName}, $TWiki::cfg{HomeTopicName} );
         }
     } else {
         # redirect to new web
-        $new_url = $session->getScriptUrl( 0, 'view',
+        $new_url = $TWiki::SESSION->getScriptUrl( 0, 'view',
             $newWeb, $TWiki::cfg{HomeTopicName} );
     }
 
-    $session->redirect( $new_url );
+    $TWiki::SESSION->redirect( $new_url );
 }
 
 =pod
 
----++ StaticMethod move($session, $oldWeb, $oldTopic, $newWeb, $newTopic, $attachment, \@refs )
+---++ StaticMethod move($oldWeb, $oldTopic, $newWeb, $newTopic, $attachment, \@refs )
 
 Move the given topic, or an attachment in the topic, correcting refs to the topic in the topic itself, and
 in the list of topics (specified as web.topic pairs) in the \@refs array.
 
-   * =$session= - reference to session object
    * =$oldWeb= - name of old web - must be untained
    * =$oldTopic= - name of old topic - must be untained
    * =$newWeb= - name of new web - must be untained
@@ -722,15 +707,14 @@
 =cut
 
 sub move {
-    my( $session, $oldWeb, $oldTopic,
+    my( $oldWeb, $oldTopic,
         $newWeb, $newTopic, $attachment, $refs ) = @_;
-    my $store = $session->{store};
 
     if( $attachment ) {
         try {
-            $store->moveAttachment( $oldWeb, $oldTopic, $attachment,
+            $TWiki::STORE->moveAttachment( $oldWeb, $oldTopic, $attachment,
                                     $newWeb, $newTopic, $attachment,
-                                    $session->{user} );
+                                    $TWiki::SESSION->{user} );
         } catch Error::Simple with {
             throw TWiki::OopsException(
                 'attention',
@@ -744,8 +728,8 @@
     }
 
     try {
-        $store->moveTopic( $oldWeb, $oldTopic, $newWeb, $newTopic,
-                           $session->{user} );
+        $TWiki::STORE->moveTopic( $oldWeb, $oldTopic, $newWeb, $newTopic,
+                           $TWiki::SESSION->{user} );
     } catch Error::Simple with {
         throw TWiki::OopsException( 'attention',
                                     web => $oldWeb,
@@ -756,14 +740,13 @@
                                                 $newTopic ] );
     };
 
-    my( $meta, $text ) = $store->readTopic( undef, $newWeb, $newTopic );
+    my( $meta, $text ) = $TWiki::STORE->readTopic( undef, $newWeb, $newTopic );
 
     if( $oldWeb ne $newWeb ) {
         # If the web changed, replace local refs to the topics
         # in $oldWeb with full $oldWeb.topic references so that
         # they still work.
-        my $renderer = $session->{renderer};
-        $renderer->replaceWebInternalReferences(
+        $TWiki::RENDER->replaceWebInternalReferences(
             \$text, $meta,
             $oldWeb, $oldTopic, $newWeb, $newTopic );
     }
@@ -779,7 +762,7 @@
        spacedTopic => TWiki::spaceOutWikiWord( $oldTopic )
       };
     $options->{spacedTopic} =~ s/ / */g;
-    $text = $session->{renderer}->forEachLine(
+    $text = $TWiki::RENDER->forEachLine(
         $text, \&TWiki::Render::replaceTopicReferences, $options );
 
     $meta->put( 'TOPICMOVED',
@@ -788,26 +771,26 @@
                  to   => $newWeb.'.'.$newTopic,
                  date => time(),
                  # SMELL: surely this should be webDotWikiname?
-                 by   => $session->{user}->wikiName(),
+                 by   => $TWiki::SESSION->{user}->wikiName(),
                 } );
 
-    $store->saveTopic( $session->{user}, $newWeb, $newTopic, $text, $meta,
+    $TWiki::STORE->saveTopic( $TWiki::SESSION->{user}, $newWeb, $newTopic, $text, $meta,
                        { minor => 1, comment => 'rename' } );
 
     # update referrers - but _not_ including the moved topic
-    _updateReferringTopics( $session, $oldWeb, $oldTopic,
+    _updateReferringTopics( $TWiki::SESSION, $oldWeb, $oldTopic,
                             $newWeb, $newTopic, $refs );
 }
 
 # Display screen so user can decide on new web and topic.
 sub _newTopicScreen {
-    my( $session, $oldWeb, $oldTopic, $newWeb, $newTopic, $attachment,
+    my( $TWiki::SESSION, $oldWeb, $oldTopic, $newWeb, $newTopic, $attachment,
         $confirm, $doAllowNonWikiWord ) = @_;
 
-    my $query = $session->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
     my $tmplname = $query->param( 'template' ) || '';
     my $tmpl = '';
-    my $skin = $session->getSkin();
+    my $skin = $TWiki::SESSION->getSkin();
     my $currentWebOnly = $query->param( 'currentwebonly' ) || '';
 
     $newTopic = $oldTopic unless ( $newTopic );
@@ -816,16 +799,16 @@
     $nonWikiWordFlag = 'checked="checked"' if( $doAllowNonWikiWord );
 
     if( $attachment ) {
-        $tmpl = $session->{templates}->readTemplate(
+        $tmpl = $TWiki::TEMPLATES->readTemplate(
             $tmplname || 'moveattachment', $skin );
         $tmpl =~ s/%FILENAME%/$attachment/go;
     } elsif( $confirm ) {
-        $tmpl = $session->{templates}->readTemplate( 'renameconfirm', $skin );
+        $tmpl = $TWiki::TEMPLATES->readTemplate( 'renameconfirm', $skin );
     } elsif( $newWeb eq $TWiki::cfg{TrashWebName} &&
                $oldWeb ne $TWiki::cfg{TrashWebName}) {
-        $tmpl = $session->{templates}->readTemplate( 'renamedelete', $skin );
+        $tmpl = $TWiki::TEMPLATES->readTemplate( 'renamedelete', $skin );
     } else {
-        $tmpl = $session->{templates}->readTemplate( 'rename', $skin );
+        $tmpl = $TWiki::TEMPLATES->readTemplate( 'rename', $skin );
     }
 
     if( !$attachment && $newWeb eq $TWiki::cfg{TrashWebName} ) {
@@ -833,7 +816,7 @@
         $newTopic = $oldWeb.$newTopic;
         my $n = 1;
         my $base = $newTopic;
-        while( $session->{store}->topicExists( $newWeb, $newTopic)) {
+        while( $TWiki::STORE->topicExists( $newWeb, $newTopic)) {
             $newTopic = $base.$n;
             $n++;
         }
@@ -847,9 +830,9 @@
         my $refs;
         my $search = '';
         if( $currentWebOnly ) {
-            $search = $session->{i18n}->maketext('(skipped)');
+            $search = $TWiki::I18N->maketext('(skipped)');
         } else {
-            $refs = getReferringTopics( $session, $oldWeb, $oldTopic, 1 );
+            $refs = getReferringTopics( $TWiki::SESSION, $oldWeb, $oldTopic, 1 );
             foreach my $entry ( sort keys %$refs ) {
                 $search .= CGI::Tr
                   (CGI::td(
@@ -865,14 +848,14 @@
                                   $refs->{$entry} ));
             }
             unless( $search ) {
-                $search = ($session->{i18n}->maketext('(none)'));
+                $search = ($TWiki::I18N->maketext('(none)'));
             } else {
                 $search = CGI::start_table().$search.CGI::end_table();
             }
         }
         $tmpl =~ s/%GLOBAL_SEARCH%/$search/o;
 
-        $refs = getReferringTopics( $session, $oldWeb, $oldTopic, 0 );
+        $refs = getReferringTopics( $TWiki::SESSION, $oldWeb, $oldTopic, 0 );
 
         $search = '';;
         foreach my $entry ( sort keys %$refs ) {
@@ -890,19 +873,19 @@
                               $refs->{$entry} ));
         }
         unless( $search ) {
-            $search = ($session->{i18n}->maketext('(none)'));
+            $search = ($TWiki::I18N->maketext('(none)'));
         } else {
             $search = CGI::start_table().$search.CGI::end_table();
         }
         $tmpl =~ s/%LOCAL_SEARCH%/$search/go;
     }
 
-    $tmpl = $session->handleCommonTags( $tmpl, $oldWeb, $oldTopic );
-    $tmpl = $session->{renderer}->getRenderedVersion( $tmpl, $oldWeb, $oldTopic );
-    $session->writeCompletePage( $tmpl );
+    $tmpl = $TWiki::SESSION->handleCommonTags( $tmpl, $oldWeb, $oldTopic );
+    $tmpl = $TWiki::RENDER->getRenderedVersion( $tmpl, $oldWeb, $oldTopic );
+    $TWiki::SESSION->writeCompletePage( $tmpl );
 }
 
-# _moveWeb($session, $oldWeb,  $newWeb, \@refs )
+# _moveWeb($TWiki::SESSION, $oldWeb,  $newWeb, \@refs )
 #
 # Move the given web, correcting refs to the web in the web itself, and
 # in the list of topics (specified as web.topic pairs) in the \@refs array.
@@ -910,22 +893,21 @@
 #
 # All permissions and lease conflicts should be resolved before calling this method.
 #
-#    * =$session= - reference to session object
+#    * =$TWiki::SESSION= - reference to session object
 #    * =$oldWeb= - name of old web
 #    * =$newWeb= - name of new web
 #    * =\@refs= - array of webg.topics that must have refs to this topic converted
 # Will throw TWiki::OopsException on an error.
 
 sub _moveWeb {
-    my( $session, $oldWeb, $newWeb, $refs ) = @_;
-    my $store = $session->{store};
+    my( $TWiki::SESSION, $oldWeb, $newWeb, $refs ) = @_;
 
     $oldWeb =~ s/\./\//go;
     $newWeb =~ s/\./\//go;
 
-    my $user = $session->{user};
+    my $user = $TWiki::SESSION->{user};
 
-    if( $store->webExists( $newWeb )) {
+    if( $TWiki::STORE->webExists( $newWeb )) {
         throw TWiki::OopsException( 'attention',
                                     web => $oldWeb,
                                     topic => '',
@@ -935,10 +917,10 @@
 
     # update referrers.  We need to do this before moving,
     # because there might be topics inside the newWeb which need updating.
-    _updateWebReferringTopics( $session, $oldWeb, $newWeb, $refs );
+    _updateWebReferringTopics( $TWiki::SESSION, $oldWeb, $newWeb, $refs );
 
     try {
-        $store->moveWeb( $oldWeb, $newWeb, $user );
+        $TWiki::STORE->moveWeb( $oldWeb, $newWeb, $user );
     } catch Error::Simple  with {
         my $e = shift;
         throw TWiki::OopsException( 'attention',
@@ -955,10 +937,10 @@
 # are resolved.
 
 sub _newWebScreen {
-    my( $session, $oldWeb, $newWeb,
+    my( $TWiki::SESSION, $oldWeb, $newWeb,
         $confirm, $webTopicInfoRef ) = @_;
 
-    my $query = $session->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
     my $tmpl = '';
 
     $newWeb = $oldWeb unless ( $newWeb );
@@ -968,7 +950,7 @@
     my $newParent = join( '/', @newParentPath );
     my $accessCheckWeb = $newParent;
     my $accessCheckTopic = $TWiki::cfg{WebPrefsTopicName};
-    my $templates = $session->{templates};
+    my $templates = $TWiki::TEMPLATES;
 
     if( $confirm eq 'getlock' ) {
         $tmpl = $templates->readTemplate( 'renamewebconfirm' );
@@ -983,7 +965,7 @@
         $newWeb = "$TWiki::cfg{TrashWebName}/$oldWeb";
         my $n = 1;
         my $base = $newWeb;
-        while( $session->{store}->webExists( $newWeb )) {
+        while( $TWiki::STORE->webExists( $newWeb )) {
             $newWeb = $base.$n;
             $n++;
         }
@@ -1000,13 +982,13 @@
     my( $movelocked, $refdenied, $reflocked ) = ( '', '', '' );
     $movelocked = join(', ', @{$webTopicInfoRef->{movelocked}} )
       if $webTopicInfoRef->{movelocked};
-    $movelocked = ($session->{i18n}->maketext('(none)')) unless $movelocked;
+    $movelocked = ($TWiki::I18N->maketext('(none)')) unless $movelocked;
     $refdenied = join(', ', @{$webTopicInfoRef->{modifydenied}} )
       if $webTopicInfoRef->{modifydenied};
-    $refdenied = ($session->{i18n}->maketext('(none)')) unless $refdenied;
+    $refdenied = ($TWiki::I18N->maketext('(none)')) unless $refdenied;
     $reflocked = join(', ', @{$webTopicInfoRef->{modifylocked}} )
       if $webTopicInfoRef->{modifylocked};
-    $reflocked = ($session->{i18n}->maketext('(none)')) unless $reflocked;
+    $reflocked = ($TWiki::I18N->maketext('(none)')) unless $reflocked;
 
     $tmpl =~ s/%MOVE_LOCKED%/$movelocked/;
     $tmpl =~ s/%REF_DENIED%/$refdenied/;
